"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiFlyout = void 0;

var _react = _interopRequireDefault(require("react"));

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
var EuiFlyout = function EuiFlyout(_ref) {
  var _ref$as = _ref.as,
      as = _ref$as === void 0 ? 'div' : _ref$as,
      _ref$role = _ref.role,
      role = _ref$role === void 0 ? 'dialog' : _ref$role,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      hideCloseButton = _ref.hideCloseButton,
      onClose = _ref.onClose,
      onKeyDown = _ref.onKeyDown,
      dataTestSubj = _ref['data-test-subj'];
  var Element = as;
  return /*#__PURE__*/_react.default.createElement(Element, {
    "data-eui": "EuiFlyout",
    "data-test-subj": dataTestSubj,
    role: role,
    onKeyDown: onKeyDown
  }, !hideCloseButton && /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    "data-test-subj": "euiFlyoutCloseButton",
    onClick: function onClick(e) {
      onClose();
      (closeButtonProps === null || closeButtonProps === void 0 ? void 0 : closeButtonProps.onClick) && closeButtonProps.onClick(e);
    }
  }), children);
};

exports.EuiFlyout = EuiFlyout;